/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  TransactionMessageCollateralDto,
  TransactionMessageCollateralDtoFromJSON,
  TransactionMessageCollateralDtoFromJSONTyped,
  TransactionMessageCollateralDtoToJSON,
} from './TransactionMessageCollateralDto';

/**
 *
 * @export
 * @interface TransactionSummary
 */
export interface TransactionSummary {
  /**
   * Unique identifier for this transaction
   * @type {string}
   * @memberof TransactionSummary
   */
  id: string;
  /**
   *
   * @type {number}
   * @memberof TransactionSummary
   */
  version?: number;
  /**
   *
   * @type {string}
   * @memberof TransactionSummary
   */
  senderBic: string;
  /**
   *
   * @type {string}
   * @memberof TransactionSummary
   */
  recipientBic: string;
  /**
   * Initiating party's IBAN number
   * @type {string}
   * @memberof TransactionSummary
   */
  senderAccount: string;
  /**
   * The sender XDC wallet/address
   * @type {string}
   * @memberof TransactionSummary
   */
  senderXdcAddress: string;
  /**
   * Counterparty IBAN number
   * @type {string}
   * @memberof TransactionSummary
   */
  recipientAccount: string;
  /**
   * The actual counterparty, either sender or receiver
   * @type {string}
   * @memberof TransactionSummary
   */
  counterPartyBic: string;
  /**
   * Transaction amount
   * @type {number}
   * @memberof TransactionSummary
   */
  amount: number;
  /**
   * Transaction currency
   * @type {string}
   * @memberof TransactionSummary
   */
  currency: string;
  /**
   * Transaction direction
   * @type {string}
   * @memberof TransactionSummary
   */
  direction: TransactionSummaryDirectionEnum;
  /**
   * Current status of the transaction
   * @type {string}
   * @memberof TransactionSummary
   */
  status: TransactionSummaryStatusEnum;
  /**
   * Transaction date in ISO-8601 zoned date-time
   * @type {Date}
   * @memberof TransactionSummary
   */
  requestDate: Date;
  /**
   * Transaction validity deadline in ISO-8601 zoned date-time
   * @type {Date}
   * @memberof TransactionSummary
   */
  validUntil: Date;
  /**
   *
   * @type {string}
   * @memberof TransactionSummary
   */
  endToEndId: string;
  /**
   *
   * @type {string}
   * @memberof TransactionSummary
   */
  referenceInfo?: string;
  /**
   *
   * @type {TransactionMessageCollateralDto}
   * @memberof TransactionSummary
   */
  collateral?: TransactionMessageCollateralDto;
  /**
   * The user that created the TX
   * @type {string}
   * @memberof TransactionSummary
   */
  initiator?: string;
  /**
   * The user that accepted ot rejected the TX
   * @type {string}
   * @memberof TransactionSummary
   */
  responder?: string;
  /**
   * The rollup TX hash
   * @type {string}
   * @memberof TransactionSummary
   */
  rollupTransactionHash?: string;
}

/**
 * @export
 */
export const TransactionSummaryDirectionEnum = {
  Inbox: 'INBOX',
  Outbox: 'OUTBOX',
} as const;
export type TransactionSummaryDirectionEnum =
  typeof TransactionSummaryDirectionEnum[keyof typeof TransactionSummaryDirectionEnum];

/**
 * @export
 */
export const TransactionSummaryStatusEnum = {
  New: 'New',
  Requested: 'Requested',
  Received: 'Received',
  Approved: 'Approved',
  Rejected: 'Rejected',
  Expired: 'Expired',
  Failed: 'Failed',
} as const;
export type TransactionSummaryStatusEnum =
  typeof TransactionSummaryStatusEnum[keyof typeof TransactionSummaryStatusEnum];

export function TransactionSummaryFromJSON(json: any): TransactionSummary {
  return TransactionSummaryFromJSONTyped(json, false);
}

export function TransactionSummaryFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): TransactionSummary {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    id: json['id'],
    version: !exists(json, 'version') ? undefined : json['version'],
    senderBic: json['senderBic'],
    recipientBic: json['recipientBic'],
    senderAccount: json['senderAccount'],
    senderXdcAddress: json['senderXdcAddress'],
    recipientAccount: json['recipientAccount'],
    counterPartyBic: json['counterPartyBic'],
    amount: json['amount'],
    currency: json['currency'],
    direction: json['direction'],
    status: json['status'],
    requestDate: new Date(json['requestDate']),
    validUntil: new Date(json['validUntil']),
    endToEndId: json['endToEndId'],
    referenceInfo: !exists(json, 'referenceInfo')
      ? undefined
      : json['referenceInfo'],
    collateral: !exists(json, 'collateral')
      ? undefined
      : TransactionMessageCollateralDtoFromJSON(json['collateral']),
    initiator: !exists(json, 'initiator') ? undefined : json['initiator'],
    responder: !exists(json, 'responder') ? undefined : json['responder'],
    rollupTransactionHash: !exists(json, 'rollupTransactionHash')
      ? undefined
      : json['rollupTransactionHash'],
  };
}

export function TransactionSummaryToJSON(
  value?: TransactionSummary | null
): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    id: value.id,
    version: value.version,
    senderBic: value.senderBic,
    recipientBic: value.recipientBic,
    senderAccount: value.senderAccount,
    senderXdcAddress: value.senderXdcAddress,
    recipientAccount: value.recipientAccount,
    counterPartyBic: value.counterPartyBic,
    amount: value.amount,
    currency: value.currency,
    direction: value.direction,
    status: value.status,
    requestDate: value.requestDate.toISOString(),
    validUntil: value.validUntil.toISOString(),
    endToEndId: value.endToEndId,
    referenceInfo: value.referenceInfo,
    collateral: TransactionMessageCollateralDtoToJSON(value.collateral),
    initiator: value.initiator,
    responder: value.responder,
    rollupTransactionHash: value.rollupTransactionHash,
  };
}
